var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import * as React from 'react';
import { AirshipToast, makeAirship } from 'react-native-airship';
import { AlertDropdown } from '../common/AlertDropdown';
import { ChallengeModal } from '../modals/ChallengeModal';
export const Airship = makeAirship();
/**
 * Shows an error alert to the user.
 * Used when some user-requested operation fails.
 */
export function showError(error) {
    console.log(error);
    // TODO: Run the errors through our translation infrastructure:
    const message = error instanceof Error ? error.message : String(error);
    Airship.show(bridge => React.createElement(AlertDropdown, { bridge: bridge, message: message }));
}
/**
 * Shows an error warning to the user.
 * Used when some user-requested operation succeeds but with a warning.
 */
export function showWarning(message) {
    Airship.show(bridge => (React.createElement(AlertDropdown, { bridge: bridge, message: message, warning: true })));
}
/**
 * Shows a message to the user.
 * Used when some user-requested operation succeeds.
 */
export function showToast(message) {
    Airship.show(bridge => React.createElement(AirshipToast, { bridge: bridge, message: message }));
}
export const showChallengeModal = () => __awaiter(void 0, void 0, void 0, function* () {
    return yield Airship.show(bridge => (React.createElement(ChallengeModal, { bridge: bridge })));
});
