var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { loadTouchState } from '../actions/TouchActions';
import * as Constants from '../constants/index';
import { enableTouchId } from '../keychain';
import { useDispatch } from '../types/ReduxTypes';
import { useHandler } from './useHandler';
import { useImports } from './useImports';
export const useCreateAccountHandler = () => {
    const imports = useImports();
    const dispatch = useDispatch();
    const { context, accountOptions } = imports;
    const handleCreateAccount = useHandler((createAccountParams) => __awaiter(void 0, void 0, void 0, function* () {
        const { username, password, pin } = createAccountParams;
        const account = yield context.createAccount(Object.assign(Object.assign({}, accountOptions), { username,
            password,
            pin }));
        account.watch('loggedIn', loggedIn => {
            if (!loggedIn)
                dispatch({ type: 'RESET_APP' });
        });
        yield setTouchOtp(account, dispatch);
        return account;
    }));
    return handleCreateAccount;
};
const setTouchOtp = (account, dispatch) => __awaiter(void 0, void 0, void 0, function* () {
    yield enableTouchId(account).catch(e => {
        console.log(e); // Fail quietly
    });
    yield account.dataStore.setItem(Constants.OTP_REMINDER_STORE_NAME, Constants.OTP_REMINDER_KEY_NAME_CREATED_AT, Date.now().toString());
    dispatch(loadTouchState());
});
